Page Menu
Home
FreeBSD
Search
Configure Global Search
Log In
Files
F109838066
D11084.id29331.diff
No One
Temporary
Actions
View File
Edit File
Delete File
View Transforms
Subscribe
Mute Notifications
Flag For Later
Award Token
Size
7 KB
Referenced Files
None
Subscribers
None
D11084.id29331.diff
View Options
Index: bin/ln/Makefile
===================================================================
--- bin/ln/Makefile
+++ bin/ln/Makefile
@@ -1,6 +1,8 @@
# @(#)Makefile 8.2 (Berkeley) 5/31/93
# $FreeBSD$
+.include <src.opts.mk>
+
PACKAGE=runtime
PROG= ln
MAN= ln.1 symlink.7
@@ -8,4 +10,8 @@
LINKS= ${BINDIR}/ln ${BINDIR}/link
MLINKS= ln.1 link.1
+.if ${MK_TESTS} != "no"
+SUBDIR+= tests
+.endif
+
.include <bsd.prog.mk>
Index: bin/ln/tests/Makefile
===================================================================
--- /dev/null
+++ bin/ln/tests/Makefile
@@ -0,0 +1,5 @@
+# $FreeBSD$
+
+ATF_TESTS_SH+= ln_test
+
+.include <bsd.test.mk>
Index: bin/ln/tests/ln_test.sh
===================================================================
--- /dev/null
+++ bin/ln/tests/ln_test.sh
@@ -0,0 +1,217 @@
+#
+# Copyright 2017 Shivansh Rai
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+# notice, this list of conditions and the following disclaimer in the
+# documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+# $FreeBSD$
+#
+
+set_umask()
+{
+ if ! umask 022; then
+ atf_fail "setting umask failed"
+ fi
+}
+
+atf_test_case L_flag
+L_flag_head()
+{
+ atf_set "descr" "Verify that when creating a hard link to a " \
+ "symbolic link, '-L' option creates a hard" \
+ "link to the target of the symbolic link"
+}
+
+L_flag_body()
+{
+ set_umask
+ atf_check touch A
+ atf_check ln -s A B
+ atf_check ln -L B C
+ stat_A=$(stat -f %i A)
+ stat_C=$(stat -f %i C)
+ atf_check_equal "$stat_A" "$stat_C"
+ atf_check -o inline:'B: symbolic link to A\n' file B
+}
+
+atf_test_case P_flag
+P_flag_head()
+{
+ atf_set "descr" "Verify that when creating a hard link to a " \
+ "symbolic link, '-P' option creates a hard " \
+ "link to the symbolic link itself"
+}
+
+P_flag_body()
+{
+ set_umask
+ atf_check touch A
+ atf_check ln -s A B
+ atf_check ln -P B C
+ stat_B=$(stat -f %i B)
+ stat_C=$(stat -f %i C)
+ atf_check_equal "$stat_B" "$stat_C"
+}
+
+atf_test_case f_flag
+f_flag_head()
+{
+ atf_set "descr" "Verify that if the target file already exists, " \
+ "'-f' option unlinks it so that link may occur"
+}
+
+f_flag_body()
+{
+ set_umask
+ atf_check touch A B
+ atf_check ln -f A B
+ stat_A=$(stat -f %i A)
+ stat_B=$(stat -f %i B)
+ atf_check_equal "$stat_A" "$stat_B"
+}
+
+atf_test_case target_exists_hard
+target_exists_hard_head()
+{
+ atf_set "descr" "Verify whether creating a hard link fails if the " \
+ "target file already exists"
+}
+
+target_exists_hard_body()
+{
+ atf_check touch A B
+ atf_check -s exit:1 -e inline:'ln: B: File exists\n' \
+ ln A B
+}
+
+atf_test_case target_exists_symbolic
+target_exists_symbolic_head()
+{
+ atf_set "descr" "Verify whether creating a symbolic link fails if " \
+ "the target file already exists"
+}
+
+target_exists_symbolic_body()
+{
+ atf_check touch A B
+ atf_check -s exit:1 -e inline:'ln: B: File exists\n' \
+ ln -s A B
+}
+
+atf_test_case shf_flag_dir
+shf_flag_dir_head() {
+ atf_set "descr" "Verify that if the target directory is a symbolic " \
+ "link, '-shf' option prevents following the link"
+}
+
+shf_flag_dir_body()
+{
+ atf_check mkdir -m 0777 A B
+ atf_check ln -s A C
+ atf_check ln -shf B C
+ atf_check -o inline:'C: symbolic link to B\n' file C
+}
+
+atf_test_case snf_flag_dir
+snf_flag_dir_head() {
+ atf_set "descr" "Verify that if the target directory is a symbolic " \
+ "link, '-snf' option prevents following the link"
+}
+
+snf_flag_dir_body()
+{
+ atf_check mkdir -m 0777 A B
+ atf_check ln -s A C
+ atf_check ln -snf B C
+ atf_check -o inline:'C: symbolic link to B\n' file C
+}
+
+atf_test_case sf_flag
+sf_flag_head()
+{
+ atf_set "descr" "Verify that if the target file already exists, " \
+ "'-sf' option unlinks it and creates a symbolic link " \
+ "to the source file"
+}
+
+sf_flag_body()
+{
+ atf_check touch A B
+ atf_check ln -sf A B
+ atf_check -o inline:'B: symbolic link to A\n' file B
+}
+
+atf_test_case s_flag
+s_flag_head()
+{
+ atf_set "descr" "Verify that '-s' option creates a symbolic link"
+}
+
+s_flag_body()
+{
+ set_umask
+ atf_check touch A
+ atf_check ln -s A B
+ atf_check -o inline:'B: symbolic link to A\n' file B
+}
+
+atf_test_case s_flag_broken
+s_flag_broken_head()
+{
+ atf_set "descr" "Verify that if the source file does not exists, '-s' " \
+ "option creates a broken symbolic link to the source file"
+}
+
+s_flag_broken_body()
+{
+ atf_check ln -s A B
+ atf_check -o inline:'B: broken symbolic link to A\n' file B
+}
+
+atf_test_case sw_flag
+sw_flag_head()
+{
+ atf_set "descr" "Verify that '-sw' option produces a warning if the " \
+ "source of a symbolic link does not currently exist"
+}
+
+sw_flag_body()
+{
+ atf_check -s exit:0 -e inline:'ln: warning: A: No such file or directory\n' \
+ ln -sw A B
+ atf_check -o inline:'B: broken symbolic link to A\n' file B
+}
+
+atf_init_test_cases()
+{
+ atf_add_test_case L_flag
+ atf_add_test_case P_flag
+ atf_add_test_case f_flag
+ atf_add_test_case target_exists_hard
+ atf_add_test_case target_exists_symbolic
+ atf_add_test_case shf_flag_dir
+ atf_add_test_case snf_flag_dir
+ atf_add_test_case sf_flag
+ atf_add_test_case s_flag
+ atf_add_test_case s_flag_broken
+ atf_add_test_case sw_flag
+}
Index: etc/mtree/BSD.tests.dist
===================================================================
--- etc/mtree/BSD.tests.dist
+++ etc/mtree/BSD.tests.dist
@@ -20,6 +20,8 @@
..
ls
..
+ ln
+ ..
mv
..
pax
File Metadata
Details
Attached
Mime Type
text/plain
Expires
Tue, Feb 11, 4:33 AM (9 h, 47 m)
Storage Engine
blob
Storage Format
Raw Data
Storage Handle
16588873
Default Alt Text
D11084.id29331.diff (7 KB)
Attached To
Mode
D11084: Add tests for ln(1)
Attached
Detach File
Event Timeline
Log In to Comment